/* Process model C form file: internalHLRProc.pr.c */
/* Portions of this file copyright 1992-2000 by OPNET, Inc. */



/* This variable carries the header into the object file */
static const char internalHLRProc_pr_c [] = "MIL_3_Tfile_Hdr_ 70B 30A opnet 7 3C79706D 3C79706D 1 brc9ccase06 y10770 0 0 none none 0 0 none 0 0 0 0 0 0                                                                                                                                                                                                                                                                                                                                                                                                                     ";
#include <string.h>



/* OPNET system definitions */
#include <opnet.h>

#if defined (__cplusplus)
extern "C" {
#endif
FSM_EXT_DECS
#if defined (__cplusplus)
} /* end of 'extern "C"' */
#endif


/* Header Block */

#include "msRecord.h"

#define INTERNAL_HLR_RCV_IN_STRM 0
#define INTERNAL_HLR_XMT_OUT_STRM 0
#define NUM_OF_MS_RECORDS 100


/* transition macros */
#define GET_REQ_FROM_SGSN (op_intrpt_type () == \
OPC_INTRPT_STRM && op_intrpt_strm () == INTERNAL_HLR_RCV_IN_STRM)

/* End of Header Block */


#if !defined (VOSD_NO_FIN)
#undef	BIN
#undef	BOUT
#define	BIN		FIN_LOCAL_FIELD(last_line_passed) = __LINE__ - _block_origin;
#define	BOUT	BIN
#define	BINIT	FIN_LOCAL_FIELD(last_line_passed) = 0; _block_origin = __LINE__;
#else
#define	BINIT
#endif /* #if !defined (VOSD_NO_FIN) */



/* State variable definitions */
typedef struct
	{
	/* Internal state tracking for FSM */
	FSM_SYS_STATE
	/* State Variables */
	char	                   		debugStr[1000];
	MSRecord	               		msRecordArray[100];
	} internalHLRProc_state;

#define pr_state_ptr            		((internalHLRProc_state*) SimI_Mod_State_Ptr)
#define debugStr                		pr_state_ptr->debugStr
#define msRecordArray           		pr_state_ptr->msRecordArray

/* This macro definition will define a local variable called	*/
/* "op_sv_ptr" in each function containing a FIN statement.	*/
/* This variable points to the state variable data structure,	*/
/* and can be used from a C debugger to display their values.	*/
#undef FIN_PREAMBLE
#define FIN_PREAMBLE	internalHLRProc_state *op_sv_ptr = pr_state_ptr;


/* No Function Block */

enum { _block_origin = __LINE__ };

#if defined (__cplusplus)
extern "C" {
#endif
	void internalHLRProc (void);
	Compcode internalHLRProc_init (void **);
	void internalHLRProc_diag (void);
	void internalHLRProc_terminate (void);
	void internalHLRProc_svar (void *, const char *, char **);
#if defined (__cplusplus)
} /* end of 'extern "C"' */
#endif




/* Process model interrupt handling procedure */


void
internalHLRProc (void)
	{
	int _block_origin = 0;
	FIN (internalHLRProc ());
	if (1)
		{
		Packet * pkptr;


		FSM_ENTER (internalHLRProc)

		FSM_BLOCK_SWITCH
			{
			/*---------------------------------------------------------*/
			/** state (init) enter executives **/
			FSM_STATE_ENTER_FORCED (0, state0_enter_exec, "init", "internalHLRProc () [init enter execs]")
				{
				List* internalHLRListPtr;
				List* subscribedInfoListPtr;
				int numRows, i;
				int imsi;
				char* apn;
				int qosReliablityClass, qosDelayClass, qosPrecedenceClass;
				int qosPeakBitRate, qosMeanBitRate, pdpType;
				char* pdpAddress; 
				QoS qosSubscribedStruct;
				PDPAddress pdpAddressStruct;
				APN apnStruct;
				
				// initialize the state variables: msRecords
				for (i=0; i < NUM_OF_MS_RECORDS; i++)
					{
					  msRecordArray[i].isSet = 0;
					}
				
				
				// open and read the InternalHLR.gdf file which consists
				// the MM context and PDP contexts of the MS subscribers
				
				internalHLRListPtr = op_prg_gdf_read ("InternalHLR");
				
				/* determine how many entries the file consists */
				numRows = op_prg_list_size(internalHLRListPtr);
				
				for (i=0; i < numRows; i++)
					{
					// obtain a list of the columnar fields in each row
					subscribedInfoListPtr = op_prg_str_decomp(op_prg_list_access(internalHLRListPtr, i), ",");
					
					// extract the values of the two fields, and put them into state variables
					imsi = atoi(op_prg_list_access (subscribedInfoListPtr,0));
					apn = op_prg_list_access (subscribedInfoListPtr,1);
					qosReliablityClass = atoi(op_prg_list_access (subscribedInfoListPtr,2));
					qosDelayClass = atoi(op_prg_list_access (subscribedInfoListPtr,3));
					qosPrecedenceClass = atoi(op_prg_list_access (subscribedInfoListPtr,4));
					qosPeakBitRate = atoi(op_prg_list_access (subscribedInfoListPtr,5));
					qosMeanBitRate = atoi(op_prg_list_access (subscribedInfoListPtr,6));
					pdpType = atoi(op_prg_list_access (subscribedInfoListPtr,7));
					pdpAddress = op_prg_list_access (subscribedInfoListPtr,8);
					
					msRecordArray[imsi].isSet = 1;
					
					qosSubscribedStruct.reliabilityClass = qosReliablityClass;
					qosSubscribedStruct.delayClass = qosDelayClass;
					qosSubscribedStruct.precedenceClass = qosPrecedenceClass;
					qosSubscribedStruct.peakBitRate = qosPeakBitRate;
					qosSubscribedStruct.meanBitRate = qosMeanBitRate;
					msRecordArray[imsi].qosSubscribed = qosSubscribedStruct;
					
					memset(pdpAddressStruct.pdpAddressValue, '\0', 16);
					pdpAddressStruct.pdpType = pdpType;
					strncpy(pdpAddressStruct.pdpAddressValue, pdpAddress, strlen(pdpAddress)+1);
					msRecordArray[imsi].pdpAddress = pdpAddressStruct;
					
					memset(apnStruct.apnNetworkID, '\0', 64);
					strncpy(apnStruct.apnNetworkID, apn, strlen(apn)+1);
					msRecordArray[imsi].apn = apnStruct;
					
					/*
					sprintf (debugStr, "Retrieve HLR Record %d. IMSI %d", i, imsi);
				    op_prg_odb_print_major ("Debug message for Internal HLR", debugStr, OPC_NIL);
					sprintf (debugStr, "Retrieve HLR Record %d. APN %s", i, msRecordArray[imsi].apn.apnNetworkID);
				    op_prg_odb_print_major ("Debug message for Internal HLR", debugStr, OPC_NIL);
					sprintf (debugStr, "Retrieve HLR Record %d. QoS Reliability %d", i, msRecordArray[imsi].qosSubscribed.reliabilityClass);
				    op_prg_odb_print_major ("Debug message for Internal HLR", debugStr, OPC_NIL);
					sprintf (debugStr, "Retrieve HLR Record %d. QoS Delay %d", i, msRecordArray[imsi].qosSubscribed.delayClass);
				    op_prg_odb_print_major ("Debug message for Internal HLR", debugStr, OPC_NIL);
					sprintf (debugStr, "Retrieve HLR Record %d. QoS Precedence %d", i, msRecordArray[imsi].qosSubscribed.precedenceClass);
				    op_prg_odb_print_major ("Debug message for Internal HLR", debugStr, OPC_NIL);
					sprintf (debugStr, "Retrieve HLR Record %d. QoS Peak Bit Rate %d", i, msRecordArray[imsi].qosSubscribed.peakBitRate);
				    op_prg_odb_print_major ("Debug message for Internal HLR", debugStr, OPC_NIL);
					sprintf (debugStr, "Retrieve HLR Record %d. QoS Mean Bit Rate %d", i, msRecordArray[imsi].qosSubscribed.meanBitRate);
				    op_prg_odb_print_major ("Debug message for Internal HLR", debugStr, OPC_NIL);
					sprintf (debugStr, "Retrieve HLR Record %d. PDP Type %d", i, msRecordArray[imsi].pdpAddress.pdpType);
				    op_prg_odb_print_major ("Debug message for Internal HLR", debugStr, OPC_NIL);
					sprintf (debugStr, "Retrieve HLR Record %d. PDP Address %s", i, msRecordArray[imsi].pdpAddress.pdpAddressValue);
				    op_prg_odb_print_major ("Debug message for Internal HLR", debugStr, OPC_NIL);
					*/
					
					
					// deallocate the subscribedInfo list contents and list
					op_prg_list_free(subscribedInfoListPtr);
					op_prg_mem_free(subscribedInfoListPtr);
					}
				// deallocate the internal HLR list contents and list
				op_prg_list_free(internalHLRListPtr);
				op_prg_mem_free(internalHLRListPtr);
				}


			/** state (init) exit executives **/
			FSM_STATE_EXIT_FORCED (0, state0_exit_exec, "init", "internalHLRProc () [init exit execs]")
				{
				}


			/** state (init) transition processing **/
			FSM_TRANSIT_FORCE (1, state1_enter_exec, ;)
				/*---------------------------------------------------------*/



			/** state (idle) enter executives **/
			FSM_STATE_ENTER_UNFORCED (1, state1_enter_exec, "idle", "internalHLRProc () [idle enter execs]")
				{
				}


			/** blocking after enter executives of unforced state. **/
			FSM_EXIT (3,internalHLRProc)


			/** state (idle) exit executives **/
			FSM_STATE_EXIT_UNFORCED (1, state1_exit_exec, "idle", "internalHLRProc () [idle exit execs]")
				{
				int intrpt_type;
				
				/* Determine the interrupt type as the model perform .	*/
				/*
				intrpt_type = op_intrpt_type ();
				if (intrpt_type == OPC_INTRPT_ENDSIM)
					{
					sprintf (debugStr, "EndSim received");
				    op_prg_odb_print_major ("Debug message for HLR", 
						debugStr, OPC_NIL);	
					}
				*/
				}


			/** state (idle) transition processing **/
			FSM_INIT_COND (GET_REQ_FROM_SGSN)
			FSM_DFLT_COND
			FSM_TEST_LOGIC ("idle")

			FSM_TRANSIT_SWITCH
				{
				FSM_CASE_TRANSIT (0, 2, state2_enter_exec, ;)
				FSM_CASE_TRANSIT (1, 1, state1_enter_exec, ;)
				}
				/*---------------------------------------------------------*/



			/** state (getRequestRcv) enter executives **/
			FSM_STATE_ENTER_FORCED (2, state2_enter_exec, "getRequestRcv", "internalHLRProc () [getRequestRcv enter execs]")
				{
				
				int imsi, result;
				Packet * getInternalHLRInfoResponsePkPtr;
				APN *apnStructPtr;
				QoS *qosSubscribedStructPtr;
				PDPAddress *pdpAddressStructPtr;
				
				pkptr = op_pk_get(INTERNAL_HLR_RCV_IN_STRM);
				
				// retrieve the IMSI from the request which is
				// the key for the Internal HLR database
				// Note: IMSI is the index to the state variable: msStructArray
				
				op_pk_nfd_get (pkptr, "imsi", &imsi);
				
				// reply SGSN with the search result
				getInternalHLRInfoResponsePkPtr = op_pk_create_fmt ("GetInternalHLRInfoResponse");
				
				if (msRecordArray[imsi].isSet == 0)
					{
					result = RECORD_NOT_FOUND;
					op_pk_nfd_set(getInternalHLRInfoResponsePkPtr, "result", result);
					op_pk_nfd_set(getInternalHLRInfoResponsePkPtr, "imsi", imsi);
					}
				else
				    {
					result = RECORD_FOUND;
				    op_pk_nfd_set(getInternalHLRInfoResponsePkPtr, "result", result);
					op_pk_nfd_set(getInternalHLRInfoResponsePkPtr, "imsi", imsi);
					
					// allocate a new data structure for APN
					apnStructPtr = (APN *) op_prg_mem_alloc (sizeof (APN));
				    // set the apn value
				    strncpy(apnStructPtr->apnNetworkID, msRecordArray[imsi].apn.apnNetworkID, 
						strlen(msRecordArray[imsi].apn.apnNetworkID)+1);
				       
					// assign the data structure to apn field in the packet
				    op_pk_nfd_set(getInternalHLRInfoResponsePkPtr, "apn", apnStructPtr,
				        op_prg_mem_copy_create, op_prg_mem_free, sizeof (APN));
					
					// allocate a new data structure for PDP Address
					pdpAddressStructPtr = (PDPAddress *) op_prg_mem_alloc (sizeof (PDPAddress));
				    
					// set the pdpAddress value
				    strncpy(pdpAddressStructPtr->pdpAddressValue, msRecordArray[imsi].pdpAddress.pdpAddressValue, 
						strlen(msRecordArray[imsi].pdpAddress.pdpAddressValue)+1);
					// set the pdpAddress type
					pdpAddressStructPtr->pdpType = msRecordArray[imsi].pdpAddress.pdpType;
				       
					// assign the data structure to pdpAddress field in the packet
				    op_pk_nfd_set(getInternalHLRInfoResponsePkPtr, "pdpAddress", pdpAddressStructPtr,
				        op_prg_mem_copy_create, op_prg_mem_free, sizeof (PDPAddress));
					
					// allocate a new data structure for QoS Subscribed
					qosSubscribedStructPtr = (QoS *) op_prg_mem_alloc (sizeof (QoS));
				    // set the attribute of the QoS subscribed
					qosSubscribedStructPtr->reliabilityClass = msRecordArray[imsi].qosSubscribed.reliabilityClass;
					qosSubscribedStructPtr->delayClass = msRecordArray[imsi].qosSubscribed.delayClass;
					qosSubscribedStructPtr->precedenceClass = msRecordArray[imsi].qosSubscribed.precedenceClass;
					qosSubscribedStructPtr->peakBitRate = msRecordArray[imsi].qosSubscribed.peakBitRate;
					qosSubscribedStructPtr->meanBitRate = msRecordArray[imsi].qosSubscribed.meanBitRate;
					
					// assign the data structure to qos field in the packet
				    op_pk_nfd_set(getInternalHLRInfoResponsePkPtr, "qos", qosSubscribedStructPtr,
				        op_prg_mem_copy_create, op_prg_mem_free, sizeof (QoS));
					
				    }
				op_pk_send(getInternalHLRInfoResponsePkPtr, INTERNAL_HLR_XMT_OUT_STRM);
				
				}


			/** state (getRequestRcv) exit executives **/
			FSM_STATE_EXIT_FORCED (2, state2_exit_exec, "getRequestRcv", "internalHLRProc () [getRequestRcv exit execs]")
				{
				}


			/** state (getRequestRcv) transition processing **/
			FSM_TRANSIT_FORCE (1, state1_enter_exec, ;)
				/*---------------------------------------------------------*/



			}


		FSM_EXIT (0,internalHLRProc)
		}
	}

#if defined (__cplusplus)
	extern "C" { 
#endif
	extern VosT_Fun_Status Vos_Catmem_Register (const char * , int , VosT_Void_Null_Proc, VosT_Address *);
	extern VosT_Address Vos_Catmem_Alloc (VosT_Address, size_t);
	extern VosT_Fun_Status Vos_Catmem_Dealloc (VosT_Address);
#if defined (__cplusplus)
	}
#endif


Compcode
internalHLRProc_init (void ** gen_state_pptr)
	{
	int _block_origin = 0;
	static VosT_Address	obtype = OPC_NIL;

	FIN (internalHLRProc_init (gen_state_pptr))

	if (obtype == OPC_NIL)
		{
		/* Initialize memory management */
		if (Vos_Catmem_Register ("proc state vars (internalHLRProc)",
			sizeof (internalHLRProc_state), Vos_Vnop, &obtype) == VOSC_FAILURE)
			{
			FRET (OPC_COMPCODE_FAILURE)
			}
		}

	*gen_state_pptr = Vos_Catmem_Alloc (obtype, 1);
	if (*gen_state_pptr == OPC_NIL)
		{
		FRET (OPC_COMPCODE_FAILURE)
		}
	else
		{
		/* Initialize FSM handling */
		((internalHLRProc_state *)(*gen_state_pptr))->current_block = 0;

		FRET (OPC_COMPCODE_SUCCESS)
		}
	}



void
internalHLRProc_diag (void)
	{
	/* No Diagnostic Block */
	}




void
internalHLRProc_terminate (void)
	{
	int _block_origin = __LINE__;

	FIN (internalHLRProc_terminate (void))

	if (1)
		{
		Packet * pkptr;

		/* No Termination Block */

		}
	Vos_Catmem_Dealloc (pr_state_ptr);

	FOUT;
	}


/* Undefine shortcuts to state variables to avoid */
/* syntax error in direct access to fields of */
/* local variable prs_ptr in internalHLRProc_svar function. */
#undef debugStr
#undef msRecordArray



void
internalHLRProc_svar (void * gen_ptr, const char * var_name, char ** var_p_ptr)
	{
	internalHLRProc_state		*prs_ptr;

	FIN (internalHLRProc_svar (gen_ptr, var_name, var_p_ptr))

	if (var_name == OPC_NIL)
		{
		*var_p_ptr = (char *)OPC_NIL;
		FOUT;
		}
	prs_ptr = (internalHLRProc_state *)gen_ptr;

	if (strcmp ("debugStr" , var_name) == 0)
		{
		*var_p_ptr = (char *) (prs_ptr->debugStr);
		FOUT;
		}
	if (strcmp ("msRecordArray" , var_name) == 0)
		{
		*var_p_ptr = (char *) (prs_ptr->msRecordArray);
		FOUT;
		}
	*var_p_ptr = (char *)OPC_NIL;

	FOUT;
	}

